
#include "stdafx.h"
#include <time.h>
#include <stdlib.h>

#include "SenseUK.h"
#pragma comment(lib,"SenseUK.lib")

#define TEST_MAX_LENGTH 512 

char cDisk[4]="";
BOOL bRet=FALSE;
DWORD i=0;
char ReadBuff[TEST_MAX_LENGTH+1]="";
char WriteBuff[TEST_MAX_LENGTH+1]="";
DWORD WritePos=0;
DWORD WriteLen=0;
DWORD ReadPos=0;
DWORD ReadLen=0;

void TestWrite()
{
    // Set WriteBuff
    for(i=0;i<TEST_MAX_LENGTH;i++)
    {
        WriteBuff[i]=1;//(unsigned char)rand();
    }

    // Write position
    WritePos=0;
    // Write length
    WriteLen=100;

    // Write
    printf("Write:Pos=%d,Len=%d\n",WritePos,WriteLen);
    bRet=UKHiddenAreaWrite(cDisk[0],WritePos,(UCHAR*)WriteBuff,WriteLen);
}

void TestRead()
{
    memset(ReadBuff,0,TEST_MAX_LENGTH);

    // Read position
    ReadPos=0;
    // Read length
    ReadLen=TEST_MAX_LENGTH;

    // Read
    printf("Read:Pos=%d,Len=%d\n",ReadPos,ReadLen);
    bRet=UKHiddenAreaRead(cDisk[0],ReadPos,(UCHAR*)ReadBuff,ReadLen);
}

int main(int argc, char* argv[])
{
    printf("TEST:\n");

    // Get removal letter
    bRet=UKGetRemovalLetter(cDisk);
    if(bRet==FALSE)
    {
        printf("Error:Get removal letter\n");
        getchar();
        return 0;
    }
    printf("RemovalLetter = %c \n",cDisk[0]);

    /*
    // Set TDES key
    // If TDES key is set, then the storage U disk hidden within the data are encrypted, or stored in clear text.
    // Note: When you set TDES key, all the data is encrypted using the key(That if the set key 
    //       is written, the next time no write the key data storage will cause confusion.)
    bRet=UKSetTdesKey((BYTE*)"1234567812345678");
    if(bRet==FALSE)
    {
        printf("Error:Set TDES key\n");
        getchar();
        return 0;
    }
    */

    // write data to hidden area
    TestWrite();
    if(bRet==FALSE)
    {
        printf("Error:write data to hidden area \n");
        getchar();
        return 0;
    }

    // Read data from hidden area 
    TestRead();
    if(bRet==FALSE)
    {
        printf("Error:Read data from hidden area\n");
        getchar();
        return 0;
    }

    printf("\nReadData:");
    for(i=0;i<ReadLen;i++)
    {
        if(i%16 == 0) printf("\n");
        printf("%02X ",(UCHAR)ReadBuff[i]);
    }
    printf("\n");
    

    printf("\nTest End.\n");
    getchar();
    return 0;
}


